Package org.apache.sysds.parser.dml

# Class DmlParser

java.lang.Object
org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>
org.antlr.v4.runtime.Parser
org.apache.sysds.parser.dml.DmlParser

public class DmlParser extends org.antlr.v4.runtime.Parser

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`DmlParser.AccumulatorAssignmentStatementContext`
`static class`
`DmlParser.AddSubExpressionContext`
`static class`
`DmlParser.AssignmentStatementContext`
`static class`
`DmlParser.AtomicExpressionContext`
`static class`
`DmlParser.BooleanAndExpressionContext`
`static class`
`DmlParser.BooleanNotExpressionContext`
`static class`
`DmlParser.BooleanOrExpressionContext`
`static class`
`DmlParser.BuiltinFunctionExpressionContext`
`static class`
`DmlParser.CommandlineParamExpressionContext`
`static class`
`DmlParser.CommandlinePositionExpressionContext`
`static class`
`DmlParser.ConstDoubleIdExpressionContext`
`static class`
`DmlParser.ConstFalseExpressionContext`
`static class`
`DmlParser.ConstIntIdExpressionContext`
`static class`
`DmlParser.ConstStringIdExpressionContext`
`static class`
`DmlParser.ConstTrueExpressionContext`
`static class`
`DmlParser.DataIdentifierContext`
`static class`
`DmlParser.DataIdExpressionContext`
`static class`
`DmlParser.DataTypeContext`
`static class`
`DmlParser.ExpressionContext`
`static class`
`DmlParser.ExternalFunctionDefExpressionContext`
`static class`
`DmlParser.ForStatementContext`
`static class`
`DmlParser.FunctionCallAssignmentStatementContext`
`static class`
`DmlParser.FunctionCallMultiAssignmentStatementContext`
`static class`
`DmlParser.FunctionStatementContext`
`static class`
`DmlParser.IfdefAssignmentStatementContext`
`static class`
`DmlParser.IfStatementContext`
`static class`
`DmlParser.ImportStatementContext`
`static class`
`DmlParser.IndexedExpressionContext`
`static class`
`DmlParser.InternalFunctionDefExpressionContext`
`static class`
`DmlParser.IterablePredicateColonExpressionContext`
`static class`
`DmlParser.IterablePredicateContext`
`static class`
`DmlParser.IterablePredicateSeqExpressionContext`
`static class`
`DmlParser.MatrixDataTypeCheckContext`
`static class`
`DmlParser.MatrixMulExpressionContext`
`static class`
`DmlParser.Ml_typeContext`
`static class`
`DmlParser.ModIntDivExpressionContext`
`static class`
`DmlParser.MultDivExpressionContext`
`static class`
`DmlParser.MultiIdExpressionContext`
`static class`
`DmlParser.ParameterizedExpressionContext`
`static class`
`DmlParser.ParForStatementContext`
`static class`
`DmlParser.PathStatementContext`
`static class`
`DmlParser.PowerExpressionContext`
`static class`
`DmlParser.ProgramrootContext`
`static class`
`DmlParser.RelationalExpressionContext`
`static class`
`DmlParser.SimpleDataIdentifierExpressionContext`
`static class`
`DmlParser.StatementContext`
`static class`
`DmlParser.StrictParameterizedExpressionContext`
`static class`
`DmlParser.StrictParameterizedKeyValueStringContext`
`static class`
`DmlParser.TypedArgAssignContext`
`static class`
`DmlParser.TypedArgNoAssignContext`
`static class`
`DmlParser.UnaryExpressionContext`
`static class`
`DmlParser.ValueTypeContext`
`static class`
`DmlParser.WhileStatementContext`

## Nested classes/interfaces inherited from class org.antlr.v4.runtime.Parser

`org.antlr.v4.runtime.Parser.TraceListener, org.antlr.v4.runtime.Parser.TrimToSizeListener`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final org.antlr.v4.runtime.atn.ATN`
`_ATN`
`static final String`
`_serializedATN`
`static final int`
`ALPHABET`
`static final int`
`COMMANDLINE_NAMED_ID`
`static final int`
`COMMANDLINE_POSITION_ID`
`static final int`
`DIGIT`
`static final int`
`DOUBLE`
`static final int`
`ID`
`static final int`
`INT`
`static final int`
`LINE_COMMENT`
`static final int`
`MULTILINE_BLOCK_COMMENT`
`static final int`
`RULE_dataIdentifier`
`static final int`
`RULE_dataType`
`static final int`
`RULE_expression`
`static final int`
`RULE_functionStatement`
`static final int`
`RULE_iterablePredicate`
`static final int`
`RULE_ml_type`
`static final int`
`RULE_parameterizedExpression`
`static final int`
`RULE_programroot`
`static final int`
`RULE_statement`
`static final int`
`RULE_strictParameterizedExpression`
`static final int`
`RULE_strictParameterizedKeyValueString`
`static final int`
`RULE_typedArgAssign`
`static final int`
`RULE_typedArgNoAssign`
`static final int`
`RULE_valueType`
`static final String[]`
`ruleNames`
`static final int`
`STRING`
`static final int`
`T__0`
`static final int`
`T__1`
`static final int`
`T__10`
`static final int`
`T__11`
`static final int`
`T__12`
`static final int`
`T__13`
`static final int`
`T__14`
`static final int`
`T__15`
`static final int`
`T__16`
`static final int`
`T__17`
`static final int`
`T__18`
`static final int`
`T__19`
`static final int`
`T__2`
`static final int`
`T__20`
`static final int`
`T__21`
`static final int`
`T__22`
`static final int`
`T__23`
`static final int`
`T__24`
`static final int`
`T__25`
`static final int`
`T__26`
`static final int`
`T__27`
`static final int`
`T__28`
`static final int`
`T__29`
`static final int`
`T__3`
`static final int`
`T__30`
`static final int`
`T__31`
`static final int`
`T__32`
`static final int`
`T__33`
`static final int`
`T__34`
`static final int`
`T__35`
`static final int`
`T__36`
`static final int`
`T__37`
`static final int`
`T__38`
`static final int`
`T__39`
`static final int`
`T__4`
`static final int`
`T__40`
`static final int`
`T__41`
`static final int`
`T__42`
`static final int`
`T__43`
`static final int`
`T__44`
`static final int`
`T__45`
`static final int`
`T__46`
`static final int`
`T__47`
`static final int`
`T__48`
`static final int`
`T__49`
`static final int`
`T__5`
`static final int`
`T__50`
`static final int`
`T__51`
`static final int`
`T__52`
`static final int`
`T__53`
`static final int`
`T__54`
`static final int`
`T__55`
`static final int`
`T__56`
`static final int`
`T__57`
`static final int`
`T__58`
`static final int`
`T__6`
`static final int`
`T__7`
`static final int`
`T__8`
`static final int`
`T__9`
`static final String[]`
`tokenNames`
Deprecated.
Use `VOCABULARY` instead.
`static final org.antlr.v4.runtime.Vocabulary`
`VOCABULARY`
`static final int`
`WHITESPACE`

### Fields inherited from class org.antlr.v4.runtime.Recognizer

`EOF`

## Constructor Summary

Constructors
Constructor
Description
`DmlParser(org.antlr.v4.runtime.TokenStream input)`

## Method Summary

Modifier and Type
Method
Description
`final DmlParser.DataIdentifierContext`
`dataIdentifier()`
`final DmlParser.DataTypeContext`
`dataType()`
`final DmlParser.ExpressionContext`
`expression()`
`final DmlParser.FunctionStatementContext`
`functionStatement()`
`org.antlr.v4.runtime.atn.ATN`
`getATN()`
`String`
`getGrammarFileName()`
`String[]`
`getRuleNames()`
`String`
`getSerializedATN()`
`String[]`
`getTokenNames()`
Deprecated.
`org.antlr.v4.runtime.Vocabulary`
`getVocabulary()`
`final DmlParser.IterablePredicateContext`
`iterablePredicate()`
`final DmlParser.Ml_typeContext`
`ml_type()`
`final DmlParser.ParameterizedExpressionContext`
`parameterizedExpression()`
`final DmlParser.ProgramrootContext`
`programroot()`
`boolean`
`sempred(org.antlr.v4.runtime.RuleContext _localctx, int ruleIndex, int predIndex)`
`final DmlParser.StatementContext`
`statement()`
`final DmlParser.StrictParameterizedExpressionContext`
`strictParameterizedExpression()`
`final DmlParser.StrictParameterizedKeyValueStringContext`
`strictParameterizedKeyValueString()`
`final DmlParser.TypedArgAssignContext`
`typedArgAssign()`
`final DmlParser.TypedArgNoAssignContext`
`typedArgNoAssign()`
`final DmlParser.ValueTypeContext`
`valueType()`

### Methods inherited from class org.antlr.v4.runtime.Parser

`addParseListener, compileParseTreePattern, compileParseTreePattern, consume, createErrorNode, createTerminalNode, dumpDFA, enterOuterAlt, enterRecursionRule, enterRecursionRule, enterRule, exitRule, getATNWithBypassAlts, getBuildParseTree, getContext, getCurrentToken, getDFAStrings, getErrorHandler, getExpectedTokens, getExpectedTokensWithinCurrentRule, getInputStream, getInvokingContext, getNumberOfSyntaxErrors, getParseInfo, getParseListeners, getPrecedence, getRuleContext, getRuleIndex, getRuleInvocationStack, getRuleInvocationStack, getSourceName, getTokenFactory, getTokenStream, getTrimParseTree, inContext, isExpectedToken, isMatchedEOF, isTrace, match, matchWildcard, notifyErrorListeners, notifyErrorListeners, precpred, pushNewRecursionContext, removeParseListener, removeParseListeners, reset, setBuildParseTree, setContext, setErrorHandler, setInputStream, setProfile, setTokenFactory, setTokenStream, setTrace, setTrimParseTree, unrollRecursionContexts`

### Methods inherited from class org.antlr.v4.runtime.Recognizer

`action, addErrorListener, getErrorHeader, getErrorListenerDispatch, getErrorListeners, getInterpreter, getRuleIndexMap, getState, getTokenErrorDisplay, getTokenType, getTokenTypeMap, removeErrorListener, removeErrorListeners, setInterpreter, setState`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### T__0

public static final int T__0

See Also:
  - Constant Field Values

### T__1

public static final int T__1

See Also:
  - Constant Field Values

### T__2

public static final int T__2

See Also:
  - Constant Field Values

### T__3

public static final int T__3

See Also:
  - Constant Field Values

### T__4

public static final int T__4

See Also:
  - Constant Field Values

### T__5

public static final int T__5

See Also:
  - Constant Field Values

### T__6

public static final int T__6

See Also:
  - Constant Field Values

### T__7

public static final int T__7

See Also:
  - Constant Field Values

### T__8

public static final int T__8

See Also:
  - Constant Field Values

### T__9

public static final int T__9

See Also:
  - Constant Field Values

### T__10

public static final int T__10

See Also:
  - Constant Field Values

### T__11

public static final int T__11

See Also:
  - Constant Field Values

### T__12

public static final int T__12

See Also:
  - Constant Field Values

### T__13

public static final int T__13

See Also:
  - Constant Field Values

### T__14

public static final int T__14

See Also:
  - Constant Field Values

### T__15

public static final int T__15

See Also:
  - Constant Field Values

### T__16

public static final int T__16

See Also:
  - Constant Field Values

### T__17

public static final int T__17

See Also:
  - Constant Field Values

### T__18

public static final int T__18

See Also:
  - Constant Field Values

### T__19

public static final int T__19

See Also:
  - Constant Field Values

### T__20

public static final int T__20

See Also:
  - Constant Field Values

### T__21

public static final int T__21

See Also:
  - Constant Field Values

### T__22

public static final int T__22

See Also:
  - Constant Field Values

### T__23

public static final int T__23

See Also:
  - Constant Field Values

### T__24

public static final int T__24

See Also:
  - Constant Field Values

### T__25

public static final int T__25

See Also:
  - Constant Field Values

### T__26

public static final int T__26

See Also:
  - Constant Field Values

### T__27

public static final int T__27

See Also:
  - Constant Field Values

### T__28

public static final int T__28

See Also:
  - Constant Field Values

### T__29

public static final int T__29

See Also:
  - Constant Field Values

### T__30

public static final int T__30

See Also:
  - Constant Field Values

### T__31

public static final int T__31

See Also:
  - Constant Field Values

### T__32

public static final int T__32

See Also:
  - Constant Field Values

### T__33

public static final int T__33

See Also:
  - Constant Field Values

### T__34

public static final int T__34

See Also:
  - Constant Field Values

### T__35

public static final int T__35

See Also:
  - Constant Field Values

### T__36

public static final int T__36

See Also:
  - Constant Field Values

### T__37

public static final int T__37

See Also:
  - Constant Field Values

### T__38

public static final int T__38

See Also:
  - Constant Field Values

### T__39

public static final int T__39

See Also:
  - Constant Field Values

### T__40

public static final int T__40

See Also:
  - Constant Field Values

### T__41

public static final int T__41

See Also:
  - Constant Field Values

### T__42

public static final int T__42

See Also:
  - Constant Field Values

### T__43

public static final int T__43

See Also:
  - Constant Field Values

### T__44

public static final int T__44

See Also:
  - Constant Field Values

### T__45

public static final int T__45

See Also:
  - Constant Field Values

### T__46

public static final int T__46

See Also:
  - Constant Field Values

### T__47

public static final int T__47

See Also:
  - Constant Field Values

### T__48

public static final int T__48

See Also:
  - Constant Field Values

### T__49

public static final int T__49

See Also:
  - Constant Field Values

### T__50

public static final int T__50

See Also:
  - Constant Field Values

### T__51

public static final int T__51

See Also:
  - Constant Field Values

### T__52

public static final int T__52

See Also:
  - Constant Field Values

### T__53

public static final int T__53

See Also:
  - Constant Field Values

### T__54

public static final int T__54

See Also:
  - Constant Field Values

### T__55

public static final int T__55

See Also:
  - Constant Field Values

### T__56

public static final int T__56

See Also:
  - Constant Field Values

### T__57

public static final int T__57

See Also:
  - Constant Field Values

### T__58

public static final int T__58

See Also:
  - Constant Field Values

### ID

public static final int ID

See Also:
  - Constant Field Values

### INT

public static final int INT

See Also:
  - Constant Field Values

### DOUBLE

public static final int DOUBLE

See Also:
  - Constant Field Values

### DIGIT

public static final int DIGIT

See Also:
  - Constant Field Values

### ALPHABET

public static final int ALPHABET

See Also:
  - Constant Field Values

### COMMANDLINE_NAMED_ID

public static final int COMMANDLINE_NAMED_ID

See Also:
  - Constant Field Values

### COMMANDLINE_POSITION_ID

public static final int COMMANDLINE_POSITION_ID

See Also:
  - Constant Field Values

### STRING

public static final int STRING

See Also:
  - Constant Field Values

### LINE_COMMENT

public static final int LINE_COMMENT

See Also:
  - Constant Field Values

### MULTILINE_BLOCK_COMMENT

public static final int MULTILINE_BLOCK_COMMENT

See Also:
  - Constant Field Values

### WHITESPACE

public static final int WHITESPACE

See Also:
  - Constant Field Values

### RULE_programroot

public static final int RULE_programroot

See Also:
  - Constant Field Values

### RULE_statement

public static final int RULE_statement

See Also:
  - Constant Field Values

### RULE_iterablePredicate

public static final int RULE_iterablePredicate

See Also:
  - Constant Field Values

### RULE_functionStatement

public static final int RULE_functionStatement

See Also:
  - Constant Field Values

### RULE_dataIdentifier

public static final int RULE_dataIdentifier

See Also:
  - Constant Field Values

### RULE_expression

public static final int RULE_expression

See Also:
  - Constant Field Values

### RULE_typedArgNoAssign

public static final int RULE_typedArgNoAssign

See Also:
  - Constant Field Values

### RULE_typedArgAssign

public static final int RULE_typedArgAssign

See Also:
  - Constant Field Values

### RULE_parameterizedExpression

public static final int RULE_parameterizedExpression

See Also:
  - Constant Field Values

### RULE_strictParameterizedExpression

public static final int RULE_strictParameterizedExpression

See Also:
  - Constant Field Values

### RULE_strictParameterizedKeyValueString

public static final int RULE_strictParameterizedKeyValueString

See Also:
  - Constant Field Values

### RULE_ml_type

public static final int RULE_ml_type

See Also:
  - Constant Field Values

### RULE_valueType

public static final int RULE_valueType

See Also:
  - Constant Field Values

### RULE_dataType

public static final int RULE_dataType

See Also:
  - Constant Field Values

### ruleNames

public static final String[] ruleNames

### VOCABULARY

public static final org.antlr.v4.runtime.Vocabulary VOCABULARY

### tokenNames

@Deprecated public static final String[] tokenNames
Deprecated.
Use `VOCABULARY` instead.

### _serializedATN

public static final String _serializedATN

See Also:
  - Constant Field Values

### _ATN

public static final org.antlr.v4.runtime.atn.ATN _ATN

## Constructor Details

### DmlParser

public DmlParser(org.antlr.v4.runtime.TokenStream input)

## Method Details

### getTokenNames

@Deprecated public String[] getTokenNames()
Deprecated.

Specified by:
  `getTokenNames` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### getVocabulary

public org.antlr.v4.runtime.Vocabulary getVocabulary()

Overrides:
  `getVocabulary` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### getGrammarFileName

public String getGrammarFileName()

Specified by:
  `getGrammarFileName` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### getRuleNames

public String[] getRuleNames()

Specified by:
  `getRuleNames` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### getSerializedATN

public String getSerializedATN()

Overrides:
  `getSerializedATN` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### getATN

public org.antlr.v4.runtime.atn.ATN getATN()

Specified by:
  `getATN` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`

### programroot

public final DmlParser.ProgramrootContext programroot() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### statement

public final DmlParser.StatementContext statement() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### iterablePredicate

public final DmlParser.IterablePredicateContext iterablePredicate() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### functionStatement

public final DmlParser.FunctionStatementContext functionStatement() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### dataIdentifier

public final DmlParser.DataIdentifierContext dataIdentifier() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### expression

public final DmlParser.ExpressionContext expression() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### typedArgNoAssign

public final DmlParser.TypedArgNoAssignContext typedArgNoAssign() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### typedArgAssign

public final DmlParser.TypedArgAssignContext typedArgAssign() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### parameterizedExpression

public final DmlParser.ParameterizedExpressionContext parameterizedExpression() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### strictParameterizedExpression

public final DmlParser.StrictParameterizedExpressionContext strictParameterizedExpression() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### strictParameterizedKeyValueString

public final DmlParser.StrictParameterizedKeyValueStringContext strictParameterizedKeyValueString() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### ml_type

public final DmlParser.Ml_typeContext ml_type() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### valueType

public final DmlParser.ValueTypeContext valueType() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### dataType

public final DmlParser.DataTypeContext dataType() throws org.antlr.v4.runtime.RecognitionException

Throws:
  `org.antlr.v4.runtime.RecognitionException`

### sempred

public boolean sempred(org.antlr.v4.runtime.RuleContext _localctx, int ruleIndex, int predIndex)

Overrides:
  `sempred` in class `org.antlr.v4.runtime.Recognizer<org.antlr.v4.runtime.Token,org.antlr.v4.runtime.atn.ParserATNSimulator>`